/***********************************************************
This program is implemented by Chris Chartier, Kenneth King, 
and Andrei Ostapenko. Please do not distribute or re-use the
code without their permission.
***********************************************************/

/* File: puzzle.h */
#ifndef __PUZZLE_H
#define __PUZZLE_H

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <ctype.h>

#define PUZSUCCESS 0
#define PUZBADINPUT -1

#define MAXSTRING 260
#define HASHSIZE 65536
#define ASCIISTART 64
#define STEPSIZE 4

#define PTRUE 1
#define PFALSE 0

#define UP -5
#define DOWN 5
#define RIGHT 1
#define LEFT -1
#define NOMOVE 0

#define WHITE 1
#define GRAY 2
#define BLACK 3



typedef struct tagPuzNode
{
	char m_strPuz[26];
	int m_iMovesToGetHere;
	unsigned char m_cHeuristic;
	char m_cMoveThatGotMeHere; /* Move that parent made to generate this node */
	struct tagPuzNode *m_ptrParent;
} PuzNode;




/*--------------------- RODDY */
int CompareNodes (PuzNode* nodeA, PuzNode* nodeB);
void ShowSolution (PuzNode* endNode, PuzNode* startNode);
int CanSolve (PuzNode * TestNode);
int FindDistance (PuzNode* node);
PuzNode * DepthFirstSearch(int DepthLimit, PuzNode *Node);
PuzNode * FindSolution(PuzNode *StartNode, PuzNode *Goal); 
int CheckIfGoal(PuzNode *node); 
int UpdateCost (PuzNode *Node); /* Roddy's Manhattan distance + moves-to-get-here*/
int UpdateDepth (void);
PuzNode* ReadFile (char* FileName);
PuzNode* CreateBadNode(void);
/*--------------------- */


/*--------------------- ANDREI */
PuzNode * Transition(PuzNode *Parent, char MoveDirection, int depth); /* returns child */
void PrintSolution (PuzNode *GoalNode);
void PrintSolutionReverse(PuzNode *Solution);
/*--------------------- */

/*--------------------- CHRIS */
PuzNode * ReadStartNodeFromFile (char *FileName);
int CheckIfDuplicate(char *PuzString); /* returns PTRUE or PFALSE */
PuzNode * CreateGoalNode();
PuzNode * SmartDepthFirstSearch(PuzNode *Node);
PuzNode * LimitedSmartDepthFirstSearch(int DepthLimit, PuzNode *Node);
void PrintNode(PuzNode *Node);

/*--------------------- */


#endif
